# HG changeset patch
# User dylanfan@zhaoxin.com
# Date 1618303674 -28800
#      Tue Apr 13 16:47:54 2021 +0800
# Node ID a0a548593e1ebcdbf6eb85261436194941b7bb49
# Parent  16dcc5929aa3e8ab08e4239c856c8e3dce001742
Add the recognition of Zhaoxin zxc\kx5000\kx6000 by fat

diff -r 16dcc5929aa3 -r a0a548593e1e configure.ac
--- a/configure.ac	Thu Mar 11 21:29:30 2021 +0100
+++ b/configure.ac	Tue Apr 13 16:47:54 2021 +0800
@@ -2337,7 +2337,8 @@
 		  x86_64/k8 x86_64/k10 x86_64/bd1 x86_64/bt1 x86_64/bt2 x86_64/zen
 		  x86_64/pentium4 x86_64/core2 x86_64/coreinhm x86_64/coreisbr
 		  x86_64/coreihwl x86_64/coreibwl x86_64/skylake x86_64/atom
-		  x86_64/silvermont x86_64/goldmont x86_64/nano"
+		  x86_64/silvermont x86_64/goldmont x86_64/nano
+		  x86_64/zxc x86_64/kx5000 x86_64/kx6000"
 	fat_functions="$fat_functions addmul_2 addlsh1_n addlsh2_n sublsh1_n"
       fi
 
diff -r 16dcc5929aa3 -r a0a548593e1e mpn/x86/fat/fat.c
--- a/mpn/x86/fat/fat.c	Thu Mar 11 21:29:30 2021 +0100
+++ b/mpn/x86/fat/fat.c	Tue Apr 13 16:47:54 2021 +0800
@@ -110,6 +110,9 @@
   { "viac3",      "CentaurHauls", MAKE_FMS (6, 0) },
   { "viac32",     "CentaurHauls", MAKE_FMS (6, 9) },
   { "nano",       "CentaurHauls", MAKE_FMS (6, 15) },
+  { "zxc",        "CentaurHauls", 0x000006FE },
+  { "kx5000",     "CentaurHauls", MAKE_FMS (7, 0x1b) },
+  { "kx6000",     "CentaurHauls", MAKE_FMS (7, 0x3b) },
 };
 
 static int
@@ -242,7 +245,7 @@
       char vendor_string[13];
       char dummy_string[12];
       long fms;
-      int family, model;
+      int family, model, stepping;
 
       __gmpn_cpuid (vendor_string, 0);
       vendor_string[12] = 0;
@@ -250,6 +253,7 @@
       fms = __gmpn_cpuid (dummy_string, 1);
       family = ((fms >> 8) & 0xf) + ((fms >> 20) & 0xff);
       model = ((fms >> 4) & 0xf) + ((fms >> 12) & 0xf0);
+      stepping = (fms & 0xf);
 
       if (strcmp (vendor_string, "GenuineIntel") == 0)
         {
@@ -488,7 +492,8 @@
 	      break;
             }
         }
-      else if (strcmp (vendor_string, "CentaurHauls") == 0)
+      else if (strcmp (vendor_string, "CentaurHauls") == 0 ||
+               strcmp (vendor_string, "  Shanghai  ") == 0)
         {
           switch (family)
             {
@@ -498,11 +503,32 @@
                 {
                   TRACE (printf ("  viac32\n"));
                 }
-	      if (model >= 15)
-		{
-                  TRACE (printf ("  nano\n"));
-		  CPUVEC_SETUP_nano;
-		}
+              if (model == 15)
+                {
+                  if (stepping == 0xE)
+                    {
+                      TRACE(printf("  zxc\n"));
+                    }
+                  else
+                    {
+                      TRACE (printf ("  nano\n"));
+                      CPUVEC_SETUP_nano;
+                    }
+                }
+			  if (model > 15)
+                {
+                  TRACE(printf("  zxc\n"));
+                }
+               break;
+            case 7:
+              if(model < 0x3B)
+                {
+                  TRACE(printf("  kx5000\n"));
+                }
+              else
+                {
+                  TRACE(printf("  kx6000\n"));
+                }
               break;
             }
         }
diff -r 16dcc5929aa3 -r a0a548593e1e mpn/x86_64/fat/fat.c
--- a/mpn/x86_64/fat/fat.c	Thu Mar 11 21:29:30 2021 +0100
+++ b/mpn/x86_64/fat/fat.c	Tue Apr 13 16:47:54 2021 +0800
@@ -94,6 +94,9 @@
   { "zen",        "AuthenticAMD", MAKE_FMS (23, 1) },
 
   { "nano",       "CentaurHauls", MAKE_FMS (6, 15) },
+  { "zxc",        "CentaurHauls", 0x000006FE },
+  { "kx5000",     "CentaurHauls", MAKE_FMS (7, 0x1b) },
+  { "kx6000",     "CentaurHauls", MAKE_FMS (7, 0x3b) },
 };
 
 static int
@@ -256,7 +259,7 @@
   char vendor_string[13];
   char dummy_string[12];
   long fms;
-  int family, model;
+  int family, model, stepping;
 
   TRACE (printf ("__gmpn_cpuvec_init:\n"));
 
@@ -271,6 +274,7 @@
   fms = __gmpn_cpuid (dummy_string, 1);
   family = ((fms >> 8) & 0xf) + ((fms >> 20) & 0xff);
   model = ((fms >> 4) & 0xf) + ((fms >> 12) & 0xf0);
+  stepping = (fms & 0xf);
 
   /* Check extended feature flags */
   __gmpn_cpuid (dummy_string, 0x80000001);
@@ -450,9 +454,43 @@
       switch (family)
 	{
 	case 6:
-	  if (model >= 15)
-	    CPUVEC_SETUP_nano;
-	  break;
+      if (model == 15)
+      {
+        if (stepping == 0xE)
+        {
+          TRACE(printf("  zxc\n"));
+          CPUVEC_SETUP_nano;
+          CPUVEC_SETUP_zxc;
+        }
+        else
+        {
+          TRACE (printf ("  nano\n"));
+          CPUVEC_SETUP_nano;
+        }
+      }
+	  if (model > 15)
+      {
+        TRACE(printf("  zxc\n"));
+        CPUVEC_SETUP_nano;
+        CPUVEC_SETUP_zxc;
+      }
+      break;
+    case 7:
+      if(model < 0x3B)
+      {
+        TRACE(printf("  kx5000\n"));
+        CPUVEC_SETUP_nano;
+        CPUVEC_SETUP_zxc;
+        CPUVEC_SETUP_kx5000;
+      }
+      else
+      {
+        TRACE(printf("  kx6000\n"));
+        CPUVEC_SETUP_nano;
+        CPUVEC_SETUP_zxc;
+        CPUVEC_SETUP_kx6000;
+      }
+    break;
 	}
     }
 
